;/*- nmi.s: front end nmi handler.
;/*
;/*
;/* There is a DEBUGGING switch to drop into the low-level
;/* debugger before invoking the handler.
;/*
;/*


ifndef NMISTACKSIZE
NMISTACKSIZE = 100
endif

public __nmi_dseg_patch_
public __nmi_handler_
public __nmi_funcp

.386

.data
__nmi_funcp dd ?
save_sp     dd ?
save_ss     dw ?

ifdef ISFLAT
__nmi_dseg_patch_ dw ?
endif

nstk     dd  NMISTACKSIZE dup (?)
nstop    label dword

.code

ifndef ISFLAT
__nmi_dseg_patch_   dw ?
endif

__nmi_handler_:
ifdef TESTING
	int   0xf3
endif
	push  ds
	mov   ds, cs:__nmi_dseg_patch_
	mov   save_ss, ss
	mov   save_sp, esp
	mov   ss, cs:__nmi_dseg_patch_
	lea   esp, nstop
	pushad
	push  es
	push  fs
	push  gs
	xor   edx, edx
	mov    fs, dx
	mov    gs, dx
	mov    es, cs:__nmi_dseg_patch_
	mov   eax, __nmi_funcp
ifdef DEBUGGING
	int   0xf3
endif
	call  eax
	pop   gs
	pop   fs
	pop   es
	popad
	mov   esp, save_sp
	mov   ss, save_ss
	pop   ds
	iretd

end
